org.cpsolver.studentsct.online.expectations

## Interface OverExpectedCriterion

- All Known Implementing Classes:
    AvoidUnbalancedWhenNoExpectations, FractionallyOverExpected, FractionallyUnbalancedWhenNoExpectations, MinimizeConflicts, MoreSpaceThanExpected, NeverOverExpected, PenaltyNotNegative, PercentageOverExpected

      public interface OverExpectedCriterion

  Over-expected criterion interface. Various implementations can be provided.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `OverExpectedCriterion.HasContext`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Integer` | `getExpected(int sectionLimit, double expectedSpace)` Expected space, for printing purposes
    `double` | `getOverExpected(Assignment<Request,Enrollment> assignment, Section section, Request request)` Expectation penalty, to be minimized

- - ### Method Detail

    - #### getOverExpected

          double getOverExpected(Assignment<Request,Enrollment> assignment,
                                 Section section,
                                 Request request)

      Expectation penalty, to be minimized
      Parameters:
        `assignment` - current assignment
        `section` - section in question
        `request` - student course request
      Returns:
        expectation penalty (typically 1.0 / number of subparts when over-expected, 0.0 otherwise)

    - #### getExpected

          Integer getExpected(int sectionLimit,
                              double expectedSpace)

      Expected space, for printing purposes
      Parameters:
        `sectionLimit` - section limit, see `Section.getLimit()`
        `expectedSpace` - expectation, see `Section.getSpaceExpected()`
      Returns:
        expected space to be printed (null if there are no expectations)